<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (version 1.7.0_80) on Wed Sep 20 14:52:14 UTC 2017 -->
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<title>RuleSource (Gradle API 4.2)</title>
<meta name="date" content="2017-09-20">
<link rel="stylesheet" type="text/css" href="../../../javadoc.css" title="Style">
</head>
<body>
<script type="text/javascript"><!--
    if (location.href.indexOf('is-external=true') == -1) {
        parent.document.title="RuleSource (Gradle API 4.2)";
    }
//-->
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar_top">
<!--   -->
</a><a href="#skip-navbar_top" title="Skip navigation links"></a><a name="navbar_top_firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../index-all.html">Index</a></li>
<li><a href="../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../org/gradle/model/Rules.html" title="annotation in org.gradle.model"><span class="strong">Prev Class</span></a></li>
<li><a href="../../../org/gradle/model/RuleTarget.html" title="annotation in org.gradle.model"><span class="strong">Next Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../index.html?org/gradle/model/RuleSource.html" target="_top">Frames</a></li>
<li><a href="RuleSource.html" target="_top">No Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../../allclasses-noframe.html">All Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor_summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#methods_inherited_from_class_java.lang.Object">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor_detail">Constr</a>&nbsp;|&nbsp;</li>
<li>Method</li>
</ul>
</div>
<a name="skip-navbar_top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">org.gradle.model</div>
<h2 title="Class RuleSource" class="title">Class RuleSource</h2>
</div>
<div class="contentContainer">
<ul class="inheritance">
<li><a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">java.lang.Object</a></li>
<li>
<ul class="inheritance">
<li>org.gradle.model.RuleSource</li>
</ul>
</li>
</ul>
<div class="description">
<ul class="blockList">
<li class="blockList">
<dl>
<dt>Direct Known Subclasses:</dt>
<dd><a href="../../../org/gradle/jvm/plugins/JvmTestSuiteBasePlugin.html" title="class in org.gradle.jvm.plugins">JvmTestSuiteBasePlugin</a>, <a href="../../../org/gradle/play/plugins/PlayDistributionPlugin.html" title="class in org.gradle.play.plugins">PlayDistributionPlugin</a>, <a href="../../../org/gradle/play/plugins/PlayRoutesPlugin.html" title="class in org.gradle.play.plugins">PlayRoutesPlugin</a>, <a href="../../../org/gradle/play/plugins/PlayTestPlugin.html" title="class in org.gradle.play.plugins">PlayTestPlugin</a>, <a href="../../../org/gradle/play/plugins/PlayTwirlPlugin.html" title="class in org.gradle.play.plugins">PlayTwirlPlugin</a></dd>
</dl>
<hr>
<br>
<pre><a href="../../../org/gradle/api/Incubating.html" title="annotation in org.gradle.api">@Incubating</a>
public class <span class="strong">RuleSource</span>
extends <a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a></pre>
<div class="block">A marker type for a class that is a collection of rules.
 <p>
 A rule source is not used like a regular Java object.
 It is a stateless container of methods and possibly constants.
 <p>
 Please consult the “Rule based model configuration” chapter of the Gradle User Guide for general information about “rules”.

 <h3>Rule methods</h3>
 <p>
 Each method that is annotated with one of the following is considered a rule:
 <ul>
 <li><a href="../../../org/gradle/model/Model.html" title="annotation in org.gradle.model"><code>Model</code></a></li>
 <li><a href="../../../org/gradle/model/Defaults.html" title="annotation in org.gradle.model"><code>Defaults</code></a></li>
 <li><a href="../../../org/gradle/model/Mutate.html" title="annotation in org.gradle.model"><code>Mutate</code></a></li>
 <li><a href="../../../org/gradle/model/Finalize.html" title="annotation in org.gradle.model"><code>Finalize</code></a></li>
 <li><a href="../../../org/gradle/model/Validate.html" title="annotation in org.gradle.model"><code>Validate</code></a></li>
 <li><a href="../../../org/gradle/model/Rules.html" title="annotation in org.gradle.model"><code>Rules</code></a></li>
 <li><a href="../../../org/gradle/platform/base/ComponentType.html" title="annotation in org.gradle.platform.base"><code>ComponentType</code></a></li>
 <li><a href="../../../org/gradle/platform/base/ComponentBinaries.html" title="annotation in org.gradle.platform.base"><code>ComponentBinaries</code></a></li>
 <li><a href="../../../org/gradle/platform/base/BinaryTasks.html" title="annotation in org.gradle.platform.base"><code>BinaryTasks</code></a></li>
 </ul>
 <p>
 Each annotation specifies the type of the rule, which affects when it will be executed.
 <p>
 The following constraints apply to all rule methods:
 <ul>
 <li>A method may only be annotated by at most one of the above annotations.</li>
 <li>A rule method may be <code>static</code> or not; it makes no difference.</li>
 <li>A rule method cannot be generic (i.e. cannot have type parameters).</li>
 <li>With the exception of <a href="../../../org/gradle/model/Model.html" title="annotation in org.gradle.model"><code>Model</code></a> methods, all methods must have at least one parameter.</li>
 <li>With the exception of <a href="../../../org/gradle/model/Model.html" title="annotation in org.gradle.model"><code>Model</code></a> methods, all methods must have a <code>void</code> return type.</li>
 </ul>
 <p>
 See <a href="../../../org/gradle/model/Model.html" title="annotation in org.gradle.model"><code>Model</code></a> for information on the significance of the return type of a <a href="../../../org/gradle/model/Model.html" title="annotation in org.gradle.model"><code>Model</code></a> method.

 <h4>Subjects and inputs</h4>
 <p>
 Method rules declare the subject and any inputs as parameters to the method.
 With the exception of <a href="../../../org/gradle/model/Model.html" title="annotation in org.gradle.model"><code>Model</code></a> methods, the subject of the rule is the, required, first parameter and all subsequent parameters are inputs.
 For a non-void <a href="../../../org/gradle/model/Model.html" title="annotation in org.gradle.model"><code>Model</code></a> method, the subject (i.e. model element being created) is the return object.
 For a void <a href="../../../org/gradle/model/Model.html" title="annotation in org.gradle.model"><code>Model</code></a> method, the subject is the first method parameter.
 <p>
 The <a href="../../../org/gradle/model/Path.html" title="annotation in org.gradle.model"><code>Path</code></a> annotation can be placed on any parameter (except the subject of <a href="../../../org/gradle/model/Model.html" title="annotation in org.gradle.model"><code>Model</code></a> rules) to indicate the model element to bind to.
 If there is no <a href="../../../org/gradle/model/Path.html" title="annotation in org.gradle.model"><code>Path</code></a> annotation, a “by-type” binding will be attempted.
 The binding scope is determined by how the rule source is applied.

 <h3>General class constraints</h3>
 <p>
 Along with the constraints on individual rule methods by their associated annotation, the following are general constraints of rule source implementations:
 <ul>
 <li>Constructors are not allowed.</li>
 <li>Inheritance hierarchies are not allowed (i.e. all rules sources must directly extend <a href="../../../org/gradle/model/RuleSource.html" title="class in org.gradle.model"><code>RuleSource</code></a>).</li>
 <li>Instance variables are not allowed.</li>
 <li>Non-final static variables are not allowed (i.e. constants are allowed).</li>
 <li>Methods cannot be overloaded.</li>
 <li>Implementations cannot be generic (i.e. cannot use type parameters).</li>
 </ul></div>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- ======== CONSTRUCTOR SUMMARY ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor_summary">
<!--   -->
</a>
<h3>Constructor Summary</h3>
<table class="overviewSummary" border="0" cellpadding="3" cellspacing="0" summary="Constructor Summary table, listing constructors, and an explanation">
<caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colOne" scope="col">Constructor and Description</th>
</tr>
<tr class="altColor">
<td class="colOne"><code><strong><a href="../../../org/gradle/model/RuleSource.html#RuleSource()">RuleSource</a></strong>()</code>&nbsp;</td>
</tr>
</table>
</li>
</ul>
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method_summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<ul class="blockList">
<li class="blockList"><a name="methods_inherited_from_class_java.lang.Object">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;java.lang.<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a></h3>
<code><a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#clone()" title="class or interface in java.lang">clone</a>, <a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#equals(java.lang.Object)" title="class or interface in java.lang">equals</a>, <a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#finalize()" title="class or interface in java.lang">finalize</a>, <a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#getClass()" title="class or interface in java.lang">getClass</a>, <a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#hashCode()" title="class or interface in java.lang">hashCode</a>, <a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#notify()" title="class or interface in java.lang">notify</a>, <a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#notifyAll()" title="class or interface in java.lang">notifyAll</a>, <a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#toString()" title="class or interface in java.lang">toString</a>, <a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#wait()" title="class or interface in java.lang">wait</a>, <a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#wait(long)" title="class or interface in java.lang">wait</a>, <a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true#wait(long,%20int)" title="class or interface in java.lang">wait</a></code></li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ========= CONSTRUCTOR DETAIL ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor_detail">
<!--   -->
</a>
<h3>Constructor Detail</h3>
<a name="RuleSource()">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>RuleSource</h4>
<pre>public&nbsp;RuleSource()</pre>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar_bottom">
<!--   -->
</a><a href="#skip-navbar_bottom" title="Skip navigation links"></a><a name="navbar_bottom_firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../index-all.html">Index</a></li>
<li><a href="../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../org/gradle/model/Rules.html" title="annotation in org.gradle.model"><span class="strong">Prev Class</span></a></li>
<li><a href="../../../org/gradle/model/RuleTarget.html" title="annotation in org.gradle.model"><span class="strong">Next Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../index.html?org/gradle/model/RuleSource.html" target="_top">Frames</a></li>
<li><a href="RuleSource.html" target="_top">No Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../../allclasses-noframe.html">All Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor_summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#methods_inherited_from_class_java.lang.Object">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor_detail">Constr</a>&nbsp;|&nbsp;</li>
<li>Method</li>
</ul>
</div>
<a name="skip-navbar_bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</body>
</html>
